<template>
  <div class="div_blockly">
    <div class="blocklyDivClass" id="blocklyDiv" ref="blocklyDivRef"></div>
    <xml style="display: none" ref="blocklyToolbox">
      <slot></slot>
    </xml>
  </div>
</template>

<script setup lang="ts">
// Add vue modules
import { ref, onMounted, watch, nextTick } from "vue";
// Adds js/ts components
import * as blocklyeditor from "@/core/blocklyeditor"
import { WORKSPACE } from '@/core/consts'
import * as Blockly from "@johnnycubides/blockly-catalejo/";

// props
const props = defineProps(['projects', 'index', 'update', 'workspace', 'plugin']);
//emits
// TODO: el emit-mounted debe ser modificado
const emit = defineEmits(["xmltext-index", "blockly-mounted"]);
// <!-- <xml style="display:none" ref="blocklyToolbox"><block type="controls_if" id=",P{W?c[wEKMe?Z{m$@wL" x="38" y="113"><statement name="DO0"><block type="controls_repeat_ext" id="`8rP4DSI/+*(AMvG-c9R"><value name="TIMES"><block type="math_number" id="(ZRz=BV]+9hV7eX^V4te"><field name="NUM">10</field></block></value></block></statement></block></xml> -->

const blocklyDivRef = ref();
const blocklyToolbox = ref();
let workspace: Blockly.WorkspaceSvg;

// -- ATENCIÓN A EVENTOS --
/** Eventos a escuchar */
const listEvents = [
  // Blockly.Events.BLOCK_CREATE,
  // Blockly.Events.BLOCK_CHANGE,
  // Blockly.Events.BLOCK_DRAG,
  // Blockly.Events.BLOCK_CREATE,
  Blockly.Events.SELECTED,
];

/** Función para atender eventos de blockly */
const onChangeBlockly = (event: any) => {
  // console.log('catalejo-msg: match: ' + event.type)
  for (const elementEvent in listEvents) {
    if (event.type === listEvents[elementEvent]) {
      const xmlDom = Blockly.Xml.workspaceToDom(workspace);
      const xmlText = Blockly.Xml.domToPrettyText(xmlDom);
      emit('xmltext-index', xmlText, props.index);
    }
  }
};

onMounted(async () => {
  // TODO: se requiere realizar una detección del contenedor div
  // para que renderice correctamente en la primera carga del componente

  // Creando el workspace
  workspace = blocklyeditor.initWorkspaceBlockly(blocklyDivRef);
  blocklyeditor.setLanguage(0);
  // Agregar un listend de eventos, en este caso, cambio de algún bloque
  workspace.addChangeListener(onChangeBlockly);
  // TODO: se requiere refactorizar el siguiente método que facilita el montaje
  // de este componente
  emit('blockly-mounted');
})

//-- WATCHERS --
// Permite cargar en el workspace de blockly los diferentes contextos
watch(() => [props.index, props.update], async ([newIndex]) => {
  // Existen proyectos a cargar?
  if (props.projects.length > 0) {
    // Conincide el workspace?
    if (props.workspace == WORKSPACE.BLOCKLY) {
      // Se asegura de repintar el DOM antes de realizar la siguiente operación
      await nextTick();
      const platform = props.projects[newIndex].config.platform;
      // El proyecto a cargar tiene información sobre la plataforma a usar?
      if (platform != undefined && platform != "") {
        // En el caso de no estar activado el plugin según plataforma, activar.
        blocklyeditor.initPluginBlockly(props.plugin, workspace);
        // Actualizar el toolbox
        workspace.updateToolbox(props.plugin.toolbox);
      }
      // Actualizar el workspace con el xml almacenado
      blocklyeditor.injectBlocksToWorkspace(
        // props.projects[newIndex].blocklycode,
        props.projects[newIndex].blocklycode,
        workspace);
      // blocklyeditor.setPositionLayout(workspace);
      Blockly.svgResize(workspace);
      // workspace.resizeContents();
      // workspace.setScale(1);
      workspace.scrollCenter();
    }
  }
})

</script>
<style>
@import "../style/blocklyeditor.css"
</style>
